log4js = require 'log4js'
logger = log4js.getLogger 'Main'

db = require './db.coffee'

TaskMaster = require './classes/TaskMaster.coffee'
RedisInterface = require './classes/RedisInterface.coffee'
Task = require './classes/Task.coffee'

ri = new RedisInterface
tm = new TaskMaster ri, db, 
  newTaskEventName: 'alal.123.newTask'
  tableName: 'alal_123_tasks'
  taskResultChannelName: 'bot_76561198139332478_task_result'
  maxTasksCount: 1
t = new Task undefined, 'sendOffer', 
  user:
    uid: '76561198078016715'
    token: 'bT7eJeTM'
  message: 'test'
  myItems: []
  theirItems: [{assetid: '7840729154', contextid: 2, appid: 730}]

respondToOfferTask = new Task undefined, 'respondToOffer',
  offerId: '1591362210'
  action: 'accept'

editProfileTask = new Task undefined, 'editProfile',
  profile:
    name: 'Nadefly'
    realName: 'Nadezhda Kulikova'
    summary: 'It\'s hard to find me and easy to loose'

uploadAvatarTask = new Task undefined, 'uploadAvatar',
  url: 'https://pp.vk.me/c637320/v637320277/1782e/xHdW8DUg0Qc.jpg'
# tm.checkTasks()
# .then (activeTasks) =>
#   console.log activeTasks
# , (err) ->
#   console.error err

# tm.emitter.on 'task.alal.action', (task) ->
#   task.run (task) ->
#     new Promise (resolve, reject) =>
#       setTimeout =>
#         reject
#           message: 123
#       , 1000
#   .then (res) ->
#     console.log 'task completed', 'result is', res
#   , (err) ->
#     console.log 'task failed', 'error is', err.message

# tm.publishTask 'bot_76561198139332478_tasks', 'bot.76561198139332478.newTask', respondToOfferTask
# .then (res) =>
#   console.log 'new task published #' + respondToOfferTask.id

# tm.publishTask 'bot_76561198139332478_tasks', 'bot.76561198139332478.newTask', t
# .then (res) =>
#   console.log 'new task published #' + t.id

# tm.publishTask 'bot_76561198139332478_tasks', 'bot.76561198139332478.newTask', editProfileTask
# .then (res) =>
#   console.log 'new task published #' + editProfileTask.id

console.log uploadAvatarTask.taskResultChannelName

tm.publishTask 'bot_76561198139332478_tasks', 'bot.76561198139332478.newTask', uploadAvatarTask
.then (res) =>
  console.log 'new task published #' + uploadAvatarTask.id

tm.emitter.on 'remoteTaskResult', (task) ->
  console.log task

# ri.request 'bot.76561198139332478.inventory', {}
# .then (res) ->
#   console.log res
# , (err) ->
#   console.log err

# # Task = require './Task.coffee'
# RedisInterface = require './classes/RedisInterface.coffee'

# ri = new RedisInterface
# # ri.emitter.on 'connect', ->
#   # ri.subscribe 'alal', (data) ->
#   #   console.log data 

#   # ri.subscribe 'alal', (data) ->
#   #   console.log data + 'asdasd'

#   # ri.subscribe 'alal', (data) ->
#   #   console.log data + '123'

# ri.get 'alal.ping', (data) =>
#   logger.info data
#   new Promise (resolve, reject) =>
#     setTimeout =>
#       resolve
#         data: 'pong'
#         status: 200
#     , 2000
# setInterval ->
#   ri.request 'alal.ping', 'ping'
#   .then (res) ->
#     logger.info res.data
# , 1000